define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	require("cordova!cordova-plugin-media");

	var Model = function() {
		this.callParent();
		this.startY;// 手指按下时的y轴坐标
		this.endY;// 手指离开时的y轴坐标
		this.mediaTimer;
		this.mediaRec;
		this.fileName;
		this.cancelRecord = false;// 是否取消录音
	};

	// 点击录音、再点击停止录音并播放刚才的录音文件
	var clickTimes = 0;
	Model.prototype.clickBtnClick = function(event) {
		var self = this;
		if (clickTimes == 0) {// 开始录音
			justep.Util.hint("开始录音");
			clickTimes = 1;
			this.comp("output2").set({
				value : "录音时长（录音成功后使用getDuration()获取）："
			});
			this.comp("output3").set({
				value : "录音文件位置（使用getCurrentPosition获取）："
			});
			this.comp("output1").set({
				value : "录音时长（使用timer计算获取）：00:00:00"
			});
			this.fileName = justep.Date.toString(new Date(), "yyyyMMddhhmmss") + ".wav";
			this.mediaRec = new Media(this.fileName, function() {
				justep.Util.hint("录音成功");
			}, function(err) {
				justep.Util.hint("录音失败！" + JSON.stringify(err));
			});
			this.mediaRec.startRecord();
		} else {// 停止录音
			justep.Util.hint("停止录音并播放刚才的录音文件");
			clickTimes = 0;// 重置标记变量
			this.mediaRec.stopRecord();
			this.mediaRec = new Media(this.fileName, function() {
				justep.Util.hint("播放成功！");
			}, function(err) {
				justep.Util.hint("--播放失败--" + JSON.stringify(err));
			});
			this.mediaRec.play();
			this.comp("output2").set({
				value : "录音时长（录音成功后使用getDuration()获取）：" + this.mediaRec.getDuration()
			});
			this.mediaRec.getCurrentPosition(function(wz) {
				self.comp("output3").set({
					value : "录音文件位置（使用getCurrentPosition获取）：" + wz
				});
			});
		}
	};

	// 按下录音--开始按下
	Model.prototype.touchBtnTouchstart = function(event) {
		justep.Util.hint("--------touchBtnTouch--start---------");
		this.cancelRecord = false;
		if (event.originalEvent.changedTouches.length > 0) {
			var t = event.originalEvent.touches[0];
			this.startY = parseInt(t.pageY);
		}
		this.fileName = justep.Date.toString(new Date(), "yyyyMMddhhmmss") + ".wav";
		this.mediaRec = new Media(this.fileName, function() {
			justep.Util.hint("录音成功");
		}, function(err) {
			justep.Util.hint("录音失败！" + JSON.stringify(err));
		});
		this.mediaRec.startRecord();
	};

	// 按下录音--捕获滑动手指的位置（当向上滑动超过150时取消录音）
	Model.prototype.touchBtnTouchmove = function(event) {
		// 第一次按下去向上滑动，就不会触发这个事件，第二次按下去可以触发，但是没有录制音频===============================求解==================================
		justep.Util.hint("--------touchBtnTouch--move---------");
		try {
			if (!this.cancelRecord && event.originalEvent.changedTouches.length > 0) {// 判断手指个数
				var t = event.originalEvent.changedTouches[0];
				this.endY = parseInt(t.pageY);
				if (this.endY - this.startY < 0) {
					if (this.startY - this.endY >= 150) {// 上滑动超过150取消录音
						justep.Util.hint("--------上滑动超过150取消录音---------");
						this.cancelRecord = true;
					}
				}
			}
		} catch (e) {
		}
	};

	// 按下录音--手指最终离开屏幕时事件
	Model.prototype.touchBtnTouchend = function(event) {
		justep.Util.hint("--------touchBtnTouch--end---------");
		if (!this.cancelRecord) {// 录音成功
			this.mediaRec.stopRecord();
		}
	};

	Model.prototype.modelLoad = function(event) {
		this.comp("output1").set({
			value : "录音时长（使用timer计算获取）："
		});
		this.comp("output2").set({
			value : "录音时长（录音成功后使用getDuration()获取）："
		});
		this.comp("output3").set({
			value : "录音文件位置（使用getCurrentPosition获取）："
		});
	};

	return Model;
});